/****************************************************************************
 *
 *   (c) 2009-2016 QGROUNDCONTROL PROJECT <http://www.qgroundcontrol.org>
 *
 * QGroundControl is licensed according to the terms in the file
 * COPYING.md in the root of the source code directory.
 *
 ****************************************************************************/

import QtQuick          2.3
import QtLocation       5.3
import QtPositioning    5.3

import QGroundControl           1.0
import QGroundControl.Controls  1.0
import QGroundControl.FlightMap 1.0

// Adds visual items generated by wima planer to the map.
Item {
    id: _root

    property var    map                 ///< Map control to show items on
    property bool   largeMapView        ///< true: map takes up entire view, false: map is in small window
    property var    wimaController
    property var    color

    property var    _map: map
    property var    _missionLineViewComponent

    // Add the mission item visuals to the map
    Repeater {
        model: largeMapView ? wimaController.missionItems : 0

        delegate: WimaMissionItemMapVisual {
            map:        _map
            color:     _root.color
//            onClicked: {
//                if (isActiveVehicle) {
//                    // Only active vehicle supports click to change current mission item
//                    guidedActionsController.confirmAction(guidedActionsController.actionSetWaypoint, Math.max(object.sequenceNumber, 1))
//                }
//            }
        }

        /*onItemAdded: {
            console.log(wimaController.missionItems.count)
        }

        onItemRemoved: {
            console.log(wimaController.missionItems.count)
        }*/
    }


    Component.onCompleted: {
        _missionLineViewComponent = missionLineViewComponent.createObject(map)
        if (_missionLineViewComponent.status === Component.Error)
            console.log(_missionLineViewComponent.errorString())
        map.addMapItem(_missionLineViewComponent)
    }

    Component.onDestruction: {
        _missionLineViewComponent.destroy()
    }

    Component {
        id: missionLineViewComponent

        MapPolyline {
            line.width: 3
            line.color: "gray"                           // Hack, can't get palette to work in here
            z:          QGroundControl.zOrderWaypointLines
            path:       wimaController.waypointPath
        }
    }
}
